// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OIF/OIAnimation.h,v 1.8 1998/04/13 00:00:06 kc Exp $

#import <OWF/OWAbstractContent.h>

@class NSLock;
@class NSMutableArray;
@class OIAnimationInstance;
@class OIAnimationFrame;
@class OIImage;

#define OIAnimationInfiniteLoopCount ((unsigned int)~0)

@interface OIAnimation : OWAbstractContent
{
    NSMutableArray *frames;
    unsigned int loopCount;
    NSMutableArray *waitingInstances;
    BOOL haveAllFrames;
    NSLock *lock;
}

- initWithLoopCount:(unsigned int)loops;

- (void)addFrame:(OIAnimationFrame *)frame;
- (void)endFrames;

- (OIImage *)animationInstance; // each call returns new instance 

- (unsigned int)loopCount;
- (void)animationInstance:(OIAnimationInstance *)instance wantsFrame:(unsigned int)frameNumber;

@end
