// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/HTTP.subproj/OWAuthorizationRealm.h,v 1.3 1998/01/26 05:50:25 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSArray, NSConditionLock, NSMutableArray, NSMutableDictionary;
@class OWHeaderDictionary;

@interface OWAuthorizationRealm : OFObject
{
    NSString *name;
    NSString *defaultsKey;
    NSMutableDictionary *credentialsByScheme;
    NSConditionLock *credentialsLock;
    NSMutableArray *cachedCredentials;
}

+ (void)registerSelector:(SEL)aSelector forScheme:(NSString *)aScheme;
+ (OWAuthorizationRealm *)realmWithName:(NSString *)aName forHostAddress:(NSString *)hostAddress;

- (NSArray *)credentials;
- (void)generateCredentialsForScheme:(NSString *)scheme challenge:(OWHeaderDictionary *)challenge reprompt:(BOOL)shouldReprompt;
- (void)setCredentials:(NSArray *)credentials forScheme:(NSString *)scheme save:(BOOL)shouldSave;

@end
