// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/HTTP.subproj/OWAuthorizationServer.h,v 1.4 1998/01/26 05:50:25 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSArray;
@class OWAddress, OWHeaderDictionary;

@interface OWAuthorizationServer : OFObject
{
    NSString *hostAddress;
    NSString *authorizationType; // @"www" or @"proxy"
    NSMutableDictionary *realmsByName;
    NSMutableDictionary *realmsByPath;
}

+ (OWAuthorizationServer *)serverForAddress:(OWAddress *)address;
+ (OWAuthorizationServer *)newServerForAddress:(OWAddress *)address;

+ (OWAuthorizationServer *)serverForProxy:(NSString *)netLocation;
+ (OWAuthorizationServer *)newServerForProxy:(NSString *)netLocation;

- (NSArray *)credentialsForPath:(NSString *)path;
- (void)generateCredentialsForChallenge:(OWHeaderDictionary *)challenge path:(NSString *)path reprompt:(BOOL)shouldReprompt;

@end
