// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Content.subproj/OWContentProtocol.h,v 1.4 1998/01/26 06:04:17 kc Exp $

#ifndef OWContentProtocolHeader
#define OWContentProtocolHeader

#import <Foundation/NSObject.h>

@class OWContentInfo, OWContentType, OWCursor;

@protocol OWContent <NSObject>

- (OWContentType *)contentType;
    // Returns the content type (e.g., text/html) for this content

- (OWContentInfo *)contentInfo;
    // NOTE: Implementors MUST call [contentInfo nullifyContent] before they are dealloc'd, or contentInfo will crash.  ContentInfo does NOT retain the content, and thus needs to know when it goes away.
@end

@protocol OWOptionalContent <NSObject>
- (OWCursor *)contentCursor;
- (unsigned long int)cacheSize;
- (BOOL)shareable;
- (BOOL)contentIsValid;
@end

#endif
