// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Content.subproj/OWDocumentTitle.h,v 1.2 1998/01/26 06:04:18 kc Exp $

#import "OWAbstractContent.h"

@class NSString, OWContentType;

#import "OWAddressProtocol.h"

// Use content-types "DocumentTitle/Guess" and "DocumentTitle/Real" for titles that are obtained from anchors and actual document titles, respectively.

@interface OWDocumentTitle : OWAbstractContent
{
    NSString *title;
    OWContentType *type;
}

// Accessing titles
+ (void)cacheRealTitle:(NSString *)aTitle forAddress:(id <OWAddress>)anAddress;
+ (void)cacheGuessTitle:(NSString *)aTitle forAddress:(id <OWAddress>)anAddress;
+ (NSString *)titleForAddress:(id <OWAddress>)address;

// Notifications of changes to titles
+ (void)addObserver:(id)anObserver selector:(SEL)aSelector address:(id <OWAddress>)anAddress;
+ (void)removeObserver:(id)anObserver address:(id <OWAddress>)anAddress;
+ (void)removeObserver:(id)anObserver;

//
- initWithTitle:(NSString *)aTitle contentType:(OWContentType *)aType;
- (NSString *)title;

@end

