// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/OWFTPSession.h,v 1.3 1998/01/24 02:18:46 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSData;
@class ONSocket, ONSocketStream;
@class OWAddress, OWPipeline, OWProcessor;

@interface OWFTPSession : OFObject
{
    NSString *sessionCacheKey;
    ONSocketStream *controlSocketStream;
    NSString *currentPath;
    NSString *currentTransferType;
    NSString *systemType;
    NSString *lastReply;
    unsigned int lastReplyIntValue;
    NSString *lastMessage;

    OWAddress *ftpAddress;
    OWPipeline *nonretainedPipeline;
    OWProcessor *nonretainedProcessor;
    BOOL abortOperation;
    ONSocket *abortSocket;
}

+ (void)readDefaults;
+ (OWFTPSession *)ftpSessionForAddress:(OWAddress *)anAddress;
+ (OWFTPSession *)ftpSessionForNetLocation:(NSString *)aNetLocation;

- initWithNetLocation:(NSString *)aNetLocation;

// Operations
- (void)fetchForProcessor:(OWProcessor *)aProcessor inPipeline:(OWPipeline *)aPipeline;
- (void)storeData:(NSData *)storeData forProcessor:(OWProcessor *)aProcessor inPipeline:(OWPipeline *)aPipeline;
- (void)removeFileAtAddressForProcessor:(OWProcessor *)aProcessor inPipeline:(OWPipeline *)aPipeline;
- (void)abortOperation;

@end
