// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Content.subproj/OWFileInfo.h,v 1.2 1998/01/26 06:04:19 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSDate, NSNumber;
@class OWAddress;

#import "OWContentProtocol.h"

@interface OWFileInfo : OFObject <OWContent>
{
    OWAddress *address;
    NSNumber *size;
    struct {
        unsigned int isDirectory:1;
        unsigned int isShortcut:1;
    } flags;
    NSDate *lastChangeDate;

    NSString *cachedName;
}

+ (OWContentType *)contentType;

- initWithAddress:(OWAddress *)anAddress size:(NSNumber *)aSize isDirectory:(BOOL)isDirectory isShortcut:(BOOL)isShortcut lastChangeDate:(NSDate *)aDate;

// Attributes

- (OWAddress *)address;
- (NSNumber *)size;
- (BOOL)isDirectory;
- (BOOL)isShortcut;
- (NSDate *)lastChangeDate;

// Derived attributes

- (NSString *)name;
- (NSString *)addressString;

@end
