// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/HTTP.subproj/OWHTTPProcessor.h,v 1.4 1998/04/15 10:10:25 wiml Exp $

#import "OWProcessor.h"

@class ONSocketStream;
@class OWAddress, OWAuthorizationServer, OWHeaderDictionary, OWURL;
@class OWNetLocation;

@interface OWHTTPProcessor : OWProcessor
{
    OWAddress *address;
    OWURL *url;
    OWURL *proxyURL;

    ONSocketStream *socketStream;
    OWHeaderDictionary *headerDictionary;
    OWAuthorizationServer *authorizationServer;
    OWAuthorizationServer *proxyAuthorizationServer;
    struct {
        unsigned int headOnly:1;
        unsigned int foundCredentials:1;
        unsigned int foundProxyCredentials:1;
    } flags;
}

+ (void)readDefaults;
    // Reads settings out of the defaults database.  (We should replace this with a notification.)

+ (int)defaultPort;
    // The port to which we connect if no port is explicitly specified in the URL (80 for HTTP, 443 for HTTPS).

+ (BOOL)shouldSpoofNetLocation:(OWNetLocation *)whatServer;
    // Returns whether the User-Agent header should be spoofed for the given server

@end

typedef enum {
    HTTP_STATUS_CONTINUE = 100,
    HTTP_STATUS_SWITCHING_PROTOCOLS = 101,

    HTTP_STATUS_OK = 200,
    HTTP_STATUS_CREATED = 201,
    HTTP_STATUS_ACCEPTED = 202,
    HTTP_STATUS_NON_AUTHORITATIVE_INFORMATION = 203,
    HTTP_STATUS_NO_CONTENT = 204,
    HTTP_STATUS_RESET_CONTENT = 205,
    HTTP_STATUS_PARTIAL_CONTENT = 206,

    HTTP_STATUS_MULTIPLE_CHOICES = 300,
    HTTP_STATUS_MOVED_PERMANENTLY = 301,
    HTTP_STATUS_MOVED_TEMPORARILY = 302,
    HTTP_STATUS_SEE_OTHER = 303,
    HTTP_STATUS_NOT_MODIFIED = 304,
    HTTP_STATUS_USE_PROXY = 305,

    HTTP_STATUS_BAD_REQUEST = 400,
    HTTP_STATUS_UNAUTHORIZED = 401,
    HTTP_STATUS_PAYMENT_REQUIRED = 402,
    HTTP_STATUS_FORBIDDEN = 403,
    HTTP_STATUS_NOT_FOUND = 404,
    HTTP_STATUS_METHOD_NOT_ALLOWED = 405,
    HTTP_STATUS_NONE_ACCEPTABLE = 406,
    HTTP_STATUS_PROXY_AUTHENTICATION_REQUIRED = 407,
    HTTP_STATUS_REQUEST_TIMEOUT = 408,
    HTTP_STATUS_CONFLICT = 409,
    HTTP_STATUS_GONE = 410,
    HTTP_STATUS_LENGTH_REQUIRED = 411,
    HTTP_STATUS_UNLESS_TRUE = 412,

    HTTP_STATUS_INTERNAL_SERVER_ERROR = 500,
    HTTP_STATUS_NOT_IMPLEMENTED = 501,
    HTTP_STATUS_BAD_GATEWAY = 502,
    HTTP_STATUS_SERVICE_UNAVAILABLE = 503,
    HTTP_STATUS_GATEWAY_TIMEOUT = 504,
} HTTPStatus;
