// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/OWMailToProcessor.h,v 1.3 1998/01/26 05:50:23 kc Exp $

#import "OWProcessor.h"

@class OWAddress;

// This is an abstract class which provides the fundamentals of parsing a mailto address, picking a good subject, etc.

// For this class to actually do anything, the -deliver method must be subclassed and the subclass must register itself as a process which converts url/mailto to Omni/Source.  (If multiple subclasses register themselves, the one with the lower cost wins.)

@interface OWMailToProcessor : OWProcessor
{
    OWAddress *mailToAddress;
    NSString *emailAddress;
    NSString *subject;
    NSString *body;
}

- (void)deliver;
    // This must be implemented by a subclass.

@end
