// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/OWNNTPSession.h,v 1.6 1998/03/20 21:27:07 bungi Exp $

#import "OWAbstractContent.h"

@class NSLock;
@class ONSocketStream;
@class OWAddress, OWContentType, OWPipeline, OWProcessor;

@interface OWNNTPSession : OWAbstractContent
{
    NSLock         *serverLock;
    ONSocketStream *controlSocketStream;
    NSString       *serverName;
    
    OWPipeline     *nonretainedPipeline;
    OWProcessor    *nonretainedProcessor;
    
    NSString       *lastReply;
    unsigned int    lastReplyIntValue;
    BOOL            abortFetch;
}

+ (NSString *) defaultNNTPServerHostName;

+ (OWContentType *) newsServerType;
+ (OWContentType *)newsgroupArticleType;
+ (OWContentType *)newsgroupHeaderListType;

+ (OWNNTPSession *) nntpSessionForAddress: (OWAddress *) address;

- initWithNewsServer: (NSString *) aServerName;

- (void)fetchForProcessor:(OWProcessor *)aProcessor inPipeline:(OWPipeline *)aPipeline;
- (void)abortFetch;

@end
