// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Content.subproj/Address.subproj/OWProxyServer.h,v 1.3 1998/02/18 03:38:45 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSArray;
@class OWURL;

@interface OWProxyServer : OFObject
{
    BOOL active;
    OWURL *proxyURL;
    NSString *description;
    NSArray *schemes;
    NSArray *destinations;
}

+ (OWURL *)proxyURLForURL:(OWURL *)aURL;
+ (NSArray *)proxyServersFromDefaults;
+ (OWProxyServer *)proxyServerWithURL:(OWURL *)aURL;

- initWithProxyURL:(OWURL *)aProxyURL;

- (OWURL *)proxyURL;
- (NSString *)description;
- (NSArray *)schemes;
- (NSArray *)destinations;
- (BOOL)isActive;

- (void)setProxyURL:(OWURL *)aProxyURL;
- (void)setDescription:(NSString *)aDescription;
- (void)setSchemes:(NSArray *)someSchemes;
- (void)setDestinations:(NSArray *)someDestinations;

- (void)activate;
- (void)deactivate;

- (BOOL)isProxyForURL:(OWURL *)aURL;

- (NSDictionary *)defaultsDictionary;

@end
