// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OWF/Pipelines.subproj/OWWebPipeline.h,v 1.2 1998/01/26 06:14:43 kc Exp $

#import "OWPipeline.h"

typedef enum {
    OWWebPipelineForwardHistoryAction,
    OWWebPipelineBackwardHistoryAction,
    OWWebPipelineReloadHistoryAction
} OWWebPipelineHistoryAction;

@interface OWWebPipeline : OWPipeline
{
    OWWebPipelineHistoryAction historyAction;
    id <OWAddress> referringAddress;

    struct {
        unsigned int proxyCacheDisabled:1;
    } webPipelineFlags;
}

- (OWWebPipelineHistoryAction)historyAction;
- (void)setHistoryAction:(OWWebPipelineHistoryAction)newHistoryAction;

- (id <OWAddress>)referringAddress;
- (void)setReferringAddress:(id <OWAddress>)anAddress;

- (BOOL)proxyCacheDisabled;
- (void)setProxyCacheDisabled:(BOOL)newDisabled;

@end
