// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniAppKit/OAFindControllerTargetProtocol.h,v 1.4 1998/04/06 11:53:57 wjs Exp $

#import <Foundation/NSObject.h>

@class NSString;

@protocol OAFindControllerTarget
- (BOOL)findString:(NSString *)textPattern ignoreCase:(BOOL)ignoreCase backwards:(BOOL)backwards wrap:(BOOL)wrap;
- (void)makeSelectionVisible;
@end

@interface NSObject (OAFindControllerAware)
- (id <OAFindControllerTarget>)omniFindControllerTarget;
@end

@protocol OASearchableContent <OAFindControllerTarget>
- (void)resetSelectionToBeginning;
- (void)resetSelectionToEnd;
@end

@interface NSObject (OAOptionalSearchableCellProtocol)
- (id <OASearchableContent>)searchableContent;
@end
