// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniDocument/ODDocumentController.h,v 1.9 1998/02/19 23:55:47 kc Exp $

#import <OmniFoundation/OFObject.h>
#import <Foundation/NSDate.h>  // For NSTimeInterval

@class NSArray, NSMutableArray, NSMutableDictionary, NSNotification, NSString;
@class NSPanel, NSMenuItem, NSApplication, NSTextField, NSButton;
@class OFScheduledEvent;
@class ODDocument;

#import <AppKit/NSNibDeclarations.h> // For IBOutlet

@interface ODDocumentController : OFObject
{
    IBOutlet NSPanel *helpPanel;

    // Info.nib
    IBOutlet NSPanel *infoPanel;
    IBOutlet NSTextField *infoPanelVersionTextField;

    //

    ODDocument *nonretainedActiveDocument;
    ODDocument *newDocument;
    NSMutableDictionary *extensionToClass;
    NSMutableDictionary *pathToDocument;
    NSMutableArray *allDocuments;
    Class defaultDocumentClass;

    OFScheduledEvent *hideSplashPanelEvent;
}

+ sharedInstance;
+ (NSString *)appVersionString;

+ (NSTimeInterval)minimumSplashPanelDisplayTime;


// API
- (NSArray *)openDocumentPaths;

- (ODDocument *)activeDocument;
- (void)setActiveDocument:(ODDocument *)aDocument;

- (void)setDefaultDocumentClass:(Class)aClass;
- (void)registerDocumentClass:(Class)aClass forFileExtension:(NSString *)anExtension;
- (void)registerDocumentClass:(Class)aClass;
- (Class)documentClassForFileExtension:(NSString *)anExtension;

- (void)registerDocument:(ODDocument *)aDocument forPath:(NSString *)aPath;
- (void)deregisterDocumentForPath:(NSString *)aPath;
- (ODDocument *)documentForPath:(NSString *)aPath;

- (ODDocument *)openFile:(NSString *)path;

- (void)switchToNextDocumentFromDocument:(ODDocument *)document;
- (void)switchToPreviousDocumentFromDocument:(ODDocument *)document;


// Actions
- (IBAction)new:(id)sender;
- (IBAction)open:(id)sender;
- (IBAction)saveAll:(id)sender;
- (IBAction)closeAll:(id)sender;
- (IBAction)showInfoPanel:(id)sender;

@end
