// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/OpenStepExtensions.subproj/NSData-OFExtensions.h,v 1.4 1998/04/04 22:30:36 luke Exp $

#import <Foundation/NSData.h>

@interface NSData (OFExtensions)

+ (NSData *) randomDataOfLength: (unsigned int) length;
// Returns a new autoreleased instance that contains the number of requested random bytes.

- initWithHexString:(NSString *)hexString;
- (NSString *)hexString;

- initWithASCII85String: (NSString *) ascii85String;
- (NSString *) ascii85String;

+ (id)dataWithBase65String:(NSString *)base64String;
- initWithBase64String: (NSString *) base64String;
- (NSString *) base64String;

- (unsigned long)firstByteSet;
    // Returns the index of the first non-zero byte in the receiver, or NSNotFound if if all the bytes in the data are zero.

- (NSData *)sha1Signature;
    // Uses the SHA-1 algorithm to compute a signature for the receiver.  Obviously, due to the dynamic nature of ObjC, and due to the fact that users will get access to the binary, this cannot be depended upon as an absolutely secure licensing mechanism, but this will prevent users from accidentally breaking the licensing agreement, which is really all we can hope for.

@end
