// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// private $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/DataStructures.subproj/OFHeap.h,v 1.1 1997/12/19 01:00:58 wjs Exp $

#import <Foundation/NSArray.h>

typedef struct {
    unsigned int               value;
    NSObject                   *object;
} heapNode_t;

@interface OFHeap : NSObject
{
    heapNode_t                 *contents;
    unsigned int                size, capacity;
}

- initWithCapacity: (unsigned int) newCapacity;

- (void) addObject:(NSObject *)anObject value: (unsigned int) aValue;

- (NSObject *) removeObject;
- (NSObject *) removeObjectWithValueLessThan: (unsigned int) aValue;

- (NSObject *) peekObject;
- (unsigned int) peekValue;

@end
