// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/Scheduling.subproj/OFInvocation.h,v 1.4 1998/03/05 07:07:11 wjs Exp $

#import "OFObject.h"

#import "OFMessageQueuePriorityProtocol.h"

typedef enum {
    OFHighPriority = 100, OFMediumPriority = 800, OFLowPriority = 1600,
} OFInvocationPriorityLevel;

#define OFInvocationNoGroup 0

@interface OFInvocation : OFObject <OFMessageQueuePriority>

- (id <NSObject>)object;
- (void)invoke;

@end

@interface OFInvocation (Inits)
- initForObject:(id <NSObject>)anObject nsInvocation:(NSInvocation *)anInvocation;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector withBool:(BOOL)aBool;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector withInt:(int)anInt;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector withInt:(int)anInt
  withInt:(int)anotherInt;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector withObject:(id <NSObject>)aWithObject;
- initForObject:(id <NSObject>)anObject selector:(SEL)aSelector withObject:(id <NSObject>)aWithObject withObject:(id <NSObject>)andAnotherObject;
@end
