// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// private $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/DataStructures.subproj/OFOid.h,v 1.3 1998/04/04 22:14:19 luke Exp $

#import "OFObject.h"

#import <Foundation/NSData.h>

#define OFOID_LENGTH (12)

// OFOid is a concrete subclass of NSData that automatically generates
// globally unique bytes each time an instance is generated.  This is
// a subclass of NSData to allow for efficient use with EOF.
@interface OFOid : NSData
{
@public
    unsigned char               bytes[OFOID_LENGTH];
}

+ (OFOid *)oid;
+ (OFOid *)zeroOid;


- initWithBytes:(const void *)bytes length:(unsigned)length;
- initWithString:(NSString *)string type:(NSString *)type;
- (const void *)bytes;
- (unsigned) length;

- (NSString *) sqlString;
- (BOOL)isZero;

- (NSString *)description;
    // Returns a '0x' prefixed hex string appropriate for entry into SQL

@end

// EOF2.2 has a bug in that custom value primary keys are sent -intValue
// even if they aren't subclasses of NSNumber.  EOF is just using this
// to see if the key is null (and interpreting zero NSNumbers as null).
// We just return 1 from this method and assume that the return value
// is never used.
@interface OFOid (EOF2_2_BugFix)
- (int)intValue;
@end

