// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// private $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/OFSimpleLock-pdo-sparc.h,v 1.4 1998/04/10 02:53:54 luke Exp $

#define OMNI_SIMPLE_LOCK

/*
 *  I'm not sure why all the below was done, but I'm wrapping it with
 *  #if defined(sun), and checking it in.  -luke
 */

#if defined(sun)

#warning FIXME: OFSimpleLock probably does not work correctly on PDO Solaris
extern void pthread_mutex_init(), pthread_mutex_destroy();
extern void pthread_mutex_lock(), pthread_mutex_trylock();
extern void pthread_mutex_unlock();


typedef void *OFSimpleLockType;

static inline void OFSimpleLockInit(OFSimpleLockType *simpleLock)
{
    /* Only allow mutexing within this process */
    pthread_mutex_init(simpleLock, NULL);
}

static inline void OFSimpleLockFree(OFSimpleLockType *simpleLock)
{
    pthread_mutex_destroy(simpleLock);
}

static inline void OFSimpleLock(OFSimpleLockType *simpleLock)
{
    pthread_mutex_lock(simpleLock);
}

static inline void OFSimpleLockTry(OFSimpleLockType *simpleLock)
{
    pthread_mutex_trylock(simpleLock);
}

static inline void OFSimpleUnlock(OFSimpleLockType *simpleLock)
{
    pthread_mutex_unlock(simpleLock);
}

#else

/*
 *  This was what the file looked like before it was hacked up locally on
 *  blackrock, apparently by Tim.
 */
#import <synch.h>

typedef mutex_t OFSimpleLockType;

static inline void OFSimpleLockInit(OFSimpleLockType *simpleLock)
{
    /* Only allow mutexing within this process */
    mutex_init(simpleLock, USYNC_THREAD, (void *)0);
}

static inline void OFSimpleLockFree(OFSimpleLockType *simpleLock)
{
    mutex_destroy(simpleLock);
}

static inline void OFSimpleLock(OFSimpleLockType *simpleLock)
{
    mutex_lock(simpleLock);
}

static inline void OFSimpleLockTry(OFSimpleLockType *simpleLock)
{
    mutex_trylock(simpleLock);
}

static inline void OFSimpleUnlock(OFSimpleLockType *simpleLock)
{
    mutex_unlock(simpleLock);
}

#endif
