// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// public $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniFoundation/OFSimpleLock.h,v 1.3 1997/10/15 03:15:36 kc Exp $

#ifndef	__TARGET_ARCHITECTURE__
#define	__TARGET_ARCHITECTURE__	__ARCHITECTURE__
#endif	__TARGET_ARCHITECTURE__

#ifndef __TARGET_ARCHITECTURE__
#error Neither __TARGET_ARCHITECTURE__ nor __ARCHITECTURE__ was defined!
#endif

#if defined(NeXT_PDO) && !defined(WINNT)
#define	OMNI_ARCH_INCLUDE(headerName)	\
	#headerName "-pdo-" __TARGET_ARCHITECTURE__ ".h"

#else
#define	OMNI_ARCH_INCLUDE(headerName)	\
	#headerName "-" __TARGET_ARCHITECTURE__ ".h"
#endif

#if defined(__SVR4) && defined(sun)
/* This goofiness with string appending doesn't work on Solaris */
#import "OFSimpleLock-pdo-sparc.h"
#else
#import OMNI_ARCH_INCLUDE(OFSimpleLock)
#endif




#ifndef OMNI_SIMPLE_LOCK
#define OMNI_SIMPLE_LOCK

#import <mach/cthreads.h>

typedef struct mutex OFSimpleLockType;

static inline void OFSimpleLockInit(OFSimpleLockType *simpleLock)
{
    mutex_init(simpleLock);
}

static inline void OFSimpleLockFree(OFSimpleLockType *simpleLock)
{
    mutex_clear(simpleLock);
}

static inline void OFSimpleLock(OFSimpleLockType *simpleLock)
{
    mutex_lock(simpleLock);
}

static inline void OFSimpleLockTry(OFSimpleLockType *simpleLock)
{
    mutex_try_lock(simpleLock);
}

static inline void OFSimpleUnlock(OFSimpleLockType *simpleLock)
{
    mutex_unlock(simpleLock);
}

#endif
