// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniHTML/Forms.subproj/OHFormElementProtocol.h,v 1.2 1998/04/10 03:30:34 wiml Exp $

#import "OWScriptResponderProtocol.h"

@class NSArray, NSString, OWContentType;
@class OWScriptEventHandlerHolder;

#import "OWScriptEvent.h" // For OWScriptEventType

@protocol OHFormElement <NSObject>

- (void)reset;
    // Resets the form element to its original value

- (void)clear;
    // Clears the form element to an empty value (unlike -reset, which sets it to its original value).  Used to clear a radio button when another is selected.

- (NSString *)name;
    // Returns the name of the form element.  (This is currently only used to clear the value of other identically-named radio buttons when a radio button is selected.)

- (NSString *)type;
    // Returns the type of the form element, eg "Button", "Checkbox", "Radio"

- (NSArray *)formValues;
    // Returns an array of OHFormValue objects to be submitted by the form

- (void)resetFromFormValues:(NSArray *)values;
    // Reset the form element to the value(s) it stored in this array

- (OWScriptEventHandlerHolder *)eventHandlers;
    // An object which holds the event handlers for this form element

@end
