// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniHTML/Forms.subproj/OHFormValue.h,v 1.1 1998/03/21 05:25:34 kc Exp $

#import <OmniFoundation/OFObject.h>

@class NSData;
@class OWContentType;

typedef enum {
   OHFormValueString, OHFormValueFilename,
} OHFormValueType;

@interface OHFormValue : OFObject
{
    NSString *name;
    NSString *valueString;
    OHFormValueType type;
}

+ (OHFormValue *)formValueWithName:(NSString *)aName valueString:(NSString *)aString;
+ (OHFormValue *)formValueWithName:(NSString *)aName valueFilepath:(NSString *)aString;

- initWithName:(NSString *)aName valueString:(NSString *)aString;
- initWithName:(NSString *)aName valueFilepath:(NSString *)aString;
- initWithPropertyList:plist;

- (NSString *)name;
- (OHFormValueType)type;
- (NSString *)valueString;

- (OWContentType *)contentType;
    // Returns the content type of the file represented by a file form element (non-file elements return nil)

- propertyList;

@end
