// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniHTML/Building.subproj/OHHTMLDisplayProcessor.h,v 1.4 1998/04/22 01:25:54 wiml Exp $

#import <OWF/OWSGMLProcessor.h>
#import "OWScriptInterpreterProtocol.h"

@class NSImage;
@class OHAppletCell, OHForm, OHHTMLDocument, OHImageMapSet, OHTableBuilder, OHTextBuilder;

typedef enum {
    LABEL_NONE,
    LABEL_UNSPECIFIED,
    LABEL_UNORDERED,
    
    LABEL_NUMBERS,
    LABEL_ROMAN,
    LABEL_SMALLROMAN,
    LABEL_LETTERS,
    LABEL_SMALLLETTERS,
    
    LABEL_DISC,
    LABEL_CIRCLE,
    LABEL_SQUARE,
    LABEL_IMAGE,
} OHHTMLListLabelType;

#import "OHTextBuilderObserverProtocol.h"

@interface OHHTMLDisplayProcessor : OWSGMLProcessor <OHTextBuilderObserver>
{
    OHTextBuilder *textBuilder;
    OHHTMLDocument *htmlDocument;
    
    struct {
	unsigned int insideBodyTag:1;
	unsigned int contentAddedToPipeline:1;
        unsigned int alwaysUsePreferenceColors:1;
    } flags;

    // Lists
    int listRecursionLevel;
    OHHTMLListLabelType listLabelType;
    NSImage *bulletImage;
    int listIndex;
    int lastListFinalIndex;
    float definitionListIndent;
    
    // Tables
    OHTableBuilder *tableBuilder;

    // Forms
    OHForm *currentForm;
    NSString *currentFormSubmitHandler;
    NSString *currentFormResetHandler;

    // Image Maps
    OHImageMapSet *mapSet;
    NSString *currentMapName;
    NSMutableArray *currentShapes;

    // Applets
    OHAppletCell *currentAppletCell;
}

- (OHTextBuilder *)textBuilder;
- (OHTextBuilder *)setTextBuilder:(OHTextBuilder *)aTextBuilder;
- (OHHTMLDocument *)htmlDocument;

@end

@interface OHHTMLDisplayProcessor (Forms)
- (void)endForm;
@end

@interface OHHTMLDisplayProcessor (General)
- (void)endAnchor;
@end

@interface OHHTMLDisplayProcessor (ImageMaps)
- (void)endMapSet;
@end
