// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniHTML/View.subproj/OHHTMLPageView.h,v 1.2 1998/04/10 03:38:45 wiml Exp $

#import "OHHTMLView.h"

@class NSLock, NSMutableArray, NSImage, NSTextStorage;
@class OIImage;
@class OWAddress, OHForm, OHHTMLAnchor, OWWebPipeline;

#import <AppKit/NSNibDeclarations.h> // For IBOutlet, IBAction
#import <Foundation/NSString.h>  /* for NSStringEncoding */
#import <OWF/OWContentProtocol.h>
#import <OWF/OWTargetProtocol.h>
#import <OWF/OWWebPipeline.h>
#import <OIF/OIImageObserverProtocol.h>
#import "OHDocumentViewProtocol.h"

@interface OHHTMLPageView : OHHTMLView <OHDocumentView, OWTarget, OIImageObserver>
{
    id <OHDocumentFrame> nonretainedFrameView;

    NSMutableArray *links;
    NSMutableArray *namedAnchors;
    OHHTMLAnchor *selectedAnchor;

    OWAddress *backgroundImageAddress;
    OIImage *backgroundOmniImage;
    NSImage *backgroundImage;
}

// Anchors
- (void)selectAnchor:(OHHTMLAnchor *)anAnchor;
- (void)selectAnchor:(OHHTMLAnchor *)anAnchor displayInAddressWell:(BOOL)shouldDisplay;
- (OHHTMLAnchor *)selectedAnchor;

- (void)followAnchor:(OHHTMLAnchor *)anchor withModifierFlags:(unsigned int)eventFlags;

// Background image
- (void)setBackgroundImageAddress:(OWAddress *)anAddress;

// Communicating with our frame
- (void)displayDocumentAtAddress:(OWAddress *)address;

// Adding links and named anchors
- (void)addLink:(OHHTMLAnchor *)aLink;
- (void)addNamedAnchor:(OHHTMLAnchor *)aNamedAnchor;

// Examining links and named anchors
// NB These aren't copied, so they could mutate out from under you
- (NSArray *)links;
- (NSArray *)namedAnchors;

@end
