// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniHTML/Scripting.subproj/OWScriptContext.h,v 1.3 1998/04/22 01:31:56 wiml Exp $

#import <OWF/OWF.h>
#import "OWScriptInterpreterProtocol.h"

@class OWScriptFrameProxy, OWScriptDocumentProxy;
@class OHHTMLDocument;

extern NSString *OWScriptContextInvalidationNotification;

/* TODO: Is there any reason this inherits from AbstractContent, or is that just a reminder of things long gone? */
@interface OWScriptContext : OWAbstractContent
{
    OHHTMLDocument *owner;
    
    NSMutableArray *interpreters;
    
    OWScriptFrameProxy *frameProxy;
    BOOL frameProxyIsHint;
    BOOL invalid;
}

- initWithOwner:(OHHTMLDocument *)newOwner;

- (void)setFrame:(OWScriptFrameProxy *)aFrame hint:(BOOL)justAHint;
- (OWScriptFrameProxy *)getFrameHint:(int *)isHint;

- (id <OWScriptInterpreter>)interpreterForLanguage:(NSString *)languageName;

// - (OWScriptFrameProxy *)frameProxy;
- (OWScriptDocumentProxy *)documentProxy;

/* for callbacks specified in HTML attributes. The second form is needed for form elements and links; see the comment in JSInterpreter.h */
- (void)setHandler:(OWScriptEventType)handlerName onObject:anObject toString:(NSString *)handlerCode;
- (void)setHandler:(OWScriptEventType)handlerName onObject:anObject parented:anotherObject toString:(NSString *)handlerCode;

- (void)invalidate;

@end

