// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /LocalDeveloper/Source/CVS/OmniGroup/OmniHTML/Scripting.subproj/OWScriptDocumentProxy.h,v 1.4 1998/04/10 03:24:53 wiml Exp $

#import <Foundation/Foundation.h>
#import <OmniFoundation/OFObject.h>

@class OWDataStream;
@class OWAddress, OWURL;
@class OWCookie;
@class OHHTMLDocument;
@class OHColorPalette;

@interface OWScriptDocumentProxy : OFObject
{
    OHHTMLDocument *theDocument;
    
    BOOL writable;
    OWDataStream *writeBuffer;
}


- initForDocument:(OHHTMLDocument *)da;

- (NSArray *)anchors;  /* array of OHHTMLAnchors */
- (NSArray *)links;    /* array of OHHTMLAnchors */
- (NSArray *)applets;  /* always nil right now */
- (NSArray *)forms;    /* array of OHForms */
- (NSArray *)images;

- (NSArray *)cookies;
- (void)addCookie:(OWCookie *)newCookie;

- (NSString *)protectionDomain;
- (void)setProtectionDomain:(NSString *)newDomain;


/* various read-only properties */
- (NSDate *)lastModified;
- (NSString *)title;
- (OHColorPalette *)colorPalette;
- (OWURL *)url;
- (OWAddress *)address;
- (OWAddress *)referringAddress;

/* for talking directly with the document. TODO: should this be eliminated? */
- (OHHTMLDocument *)htmlDocument;

/* for writable documents */
- (BOOL)isWritable;
- (void)writeData:(NSData *)data;
- (void)setWriteBuffer:(OWDataStream *)strm; /* TODO: invent better mechanism */

@end
