// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniHTML/Scripting.subproj/OWScriptInterpreterProtocol.h,v 1.4 1998/04/22 01:35:23 wiml Exp $

/* NeXT-gcc import bug workaround */
#ifndef OWScriptInterpreterProtocol_H
#define OWScriptInterpreterProtocol_H

#import <Foundation/Foundation.h>
#import "OWScriptEvent.h"

@class OWScriptContext;
@class OWScriptFrameProxy, OWScriptDocumentProxy;

@protocol OWScriptInterpreter <NSObject>

- (BOOL)setLanguage:(NSString *)scriptLanguage;
    // Returns YES if the interpreter can handle the specified language, NO otherwise.

- (void)execute:(NSData *)code synchronous:(BOOL)isSynchronous;
- (NSData *)evaluate:(NSData *)code;

// Sometimes the frame isn't known soon enough, but we can guess
- (void)setFrame:(OWScriptFrameProxy *)aFrame hint:(BOOL)isHint;

/* how interpreters are created */
- initWithContext:(OWScriptContext *)nonretainedCtxt;

/* When the context is deallocated */
- (void)invalidateContext;

/* for consistency checks */
- (OWScriptContext *)context;

/* for callbacks specified in HTML attributes */
- (void)setHandler:(OWScriptEventType)handlerName onObject:anObject toString:(NSString *)handlerCode;
- (void)setHandler:(OWScriptEventType)handlerName onObject:anObject parented:anotherObject toString:(NSString *)handlerCode;

@end

#endif /* OWScriptInterpreterProtocol_H */

