// Starting with Rhapsody RDR, Apple added PNG support to the AppKit.  This is fine and good except that they didn't rename all of their PNG symbols to have a NS_ prefix.  This means that you cannot link the default PNG library with your code w/o doing your own renaming.
//
// We still want to use our own PNG library to get incremental image loading (which Apple's API doesn't provide).
//
// This list of defines was produced with the command:
//
// nm -g $OMNI_BUILDOUTPUT/Frameworks/PNG/objects-optimized-debug/*.i386.o | egrep " [DTS] " | awk '{print $3}' | sed 's/^_//' | awk '{printf "#define omni_%s\t%s\n", $1, $1}'

#ifndef _PNG_RENAME
#define _PNG_RENAME
 
#define png_IDAT        omni_png_IDAT
#define png_IEND        omni_png_IEND
#define png_IHDR        omni_png_IHDR
#define png_PLTE        omni_png_PLTE
#define png_bKGD        omni_png_bKGD
#define png_cHRM        omni_png_cHRM
#define png_calculate_crc       omni_png_calculate_crc
#define png_check_sig   omni_png_check_sig
#define png_gAMA        omni_png_gAMA
#define png_hIST        omni_png_hIST
#define png_oFFs        omni_png_oFFs
#define png_pHYs        omni_png_pHYs
#define png_pass_dsp_mask       omni_png_pass_dsp_mask
#define png_pass_inc    omni_png_pass_inc
#define png_pass_mask   omni_png_pass_mask
#define png_pass_start  omni_png_pass_start
#define png_pass_yinc   omni_png_pass_yinc
#define png_pass_ystart omni_png_pass_ystart
#define png_reset_crc   omni_png_reset_crc
#define png_sBIT        omni_png_sBIT
#define png_sig omni_png_sig
#define png_tEXt        omni_png_tEXt
#define png_tIME        omni_png_tIME
#define png_tRNS        omni_png_tRNS
#define png_zTXt        omni_png_zTXt
#define png_zalloc      omni_png_zalloc
#define png_zfree       omni_png_zfree
#define png_read_IHDR   omni_png_read_IHDR
#define png_read_PLTE   omni_png_read_PLTE
#define png_read_bKGD   omni_png_read_bKGD
#define png_read_cHRM   omni_png_read_cHRM
#define png_read_gAMA   omni_png_read_gAMA
#define png_read_hIST   omni_png_read_hIST
#define png_read_oFFs   omni_png_read_oFFs
#define png_read_pHYs   omni_png_read_pHYs
#define png_read_sBIT   omni_png_read_sBIT
#define png_read_tEXt   omni_png_read_tEXt
#define png_read_tIME   omni_png_read_tIME
#define png_read_tRNS   omni_png_read_tRNS
#define png_read_zTXt   omni_png_read_zTXt
#define png_read_destroy        omni_png_read_destroy
#define png_read_end    omni_png_read_end
#define png_read_image  omni_png_read_image
#define png_read_info   omni_png_read_info
#define png_read_init   omni_png_read_init
#define png_read_row    omni_png_read_row
#define png_read_rows   omni_png_read_rows
#define png_start_read_image    omni_png_start_read_image
#define png_build_gamma_table   omni_png_build_gamma_table
#define png_build_grayscale_palette     omni_png_build_grayscale_palette
#define png_correct_palette     omni_png_correct_palette
#define png_do_background       omni_png_do_background
#define png_do_chop     omni_png_do_chop
#define png_do_dither   omni_png_do_dither
#define png_do_expand   omni_png_do_expand
#define png_do_expand_palette   omni_png_do_expand_palette
#define png_do_gamma    omni_png_do_gamma
#define png_do_gray_to_rgb      omni_png_do_gray_to_rgb
#define png_do_read_rgbx        omni_png_do_read_rgbx
#define png_do_read_transformations     omni_png_do_read_transformations
#define png_do_read_xrgb        omni_png_do_read_xrgb
#define png_do_unpack   omni_png_do_unpack
#define png_do_unshift  omni_png_do_unshift
#define png_init_read_transformations   omni_png_init_read_transformations
#define png_set_background      omni_png_set_background
#define png_set_dither  omni_png_set_dither
#define png_set_expand  omni_png_set_expand
#define png_set_gamma   omni_png_set_gamma
#define png_set_gray_to_rgb     omni_png_set_gray_to_rgb
#define png_set_strip_16        omni_png_set_strip_16
#define png_combine_row omni_png_combine_row
#define png_crc_read    omni_png_crc_read
#define png_crc_skip    omni_png_crc_skip
#define png_do_read_interlace   omni_png_do_read_interlace
#define png_get_uint_16 omni_png_get_uint_16
#define png_get_uint_32 omni_png_get_uint_32
#define png_handle_IHDR omni_png_handle_IHDR
#define png_handle_PLTE omni_png_handle_PLTE
#define png_handle_bKGD omni_png_handle_bKGD
#define png_handle_cHRM omni_png_handle_cHRM
#define png_handle_gAMA omni_png_handle_gAMA
#define png_handle_hIST omni_png_handle_hIST
#define png_handle_oFFs omni_png_handle_oFFs
#define png_handle_pHYs omni_png_handle_pHYs
#define png_handle_sBIT omni_png_handle_sBIT
#define png_handle_tEXt omni_png_handle_tEXt
#define png_handle_tIME omni_png_handle_tIME
#define png_handle_tRNS omni_png_handle_tRNS
#define png_handle_zTXt omni_png_handle_zTXt
#define png_read_filter_row     omni_png_read_filter_row
#define png_read_finish_row     omni_png_read_finish_row
#define png_read_start_row      omni_png_read_start_row
#define png_error       omni_png_error
#define png_free        omni_png_free
#define png_init_io     omni_png_init_io
#define png_large_free  omni_png_large_free
#define png_large_malloc        omni_png_large_malloc
#define png_malloc      omni_png_malloc
#define png_read_data   omni_png_read_data
#define png_realloc     omni_png_realloc
#define png_warning     omni_png_warning
#define png_write_data  omni_png_write_data
#define png_do_bgr      omni_png_do_bgr
#define png_do_invert   omni_png_do_invert
#define png_do_swap     omni_png_do_swap
#define png_set_bgr     omni_png_set_bgr
#define png_set_interlace_handling      omni_png_set_interlace_handling
#define png_set_invert_mono     omni_png_set_invert_mono
#define png_set_packing omni_png_set_packing
#define png_set_rgbx    omni_png_set_rgbx
#define png_set_shift   omni_png_set_shift
#define png_set_swap    omni_png_set_swap
#define png_set_xrgb    omni_png_set_xrgb
#define png_convert_from_struct_tm      omni_png_convert_from_struct_tm
#define png_convert_from_time_t omni_png_convert_from_time_t
#define png_info_init   omni_png_info_init
#define png_write_destroy       omni_png_write_destroy
#define png_write_end   omni_png_write_end
#define png_write_image omni_png_write_image
#define png_write_info  omni_png_write_info
#define png_write_init  omni_png_write_init
#define png_write_row   omni_png_write_row
#define png_write_rows  omni_png_write_rows
#define png_do_pack     omni_png_do_pack
#define png_do_shift    omni_png_do_shift
#define png_do_write_rgbx       omni_png_do_write_rgbx
#define png_do_write_transformations    omni_png_do_write_transformations
#define png_do_write_xrgb       omni_png_do_write_xrgb
#define png_do_write_interlace  omni_png_do_write_interlace
#define png_save_uint_16        omni_png_save_uint_16
#define png_save_uint_32        omni_png_save_uint_32
#define png_write_IDAT  omni_png_write_IDAT
#define png_write_IEND  omni_png_write_IEND
#define png_write_IHDR  omni_png_write_IHDR
#define png_write_PLTE  omni_png_write_PLTE
#define png_write_bKGD  omni_png_write_bKGD
#define png_write_cHRM  omni_png_write_cHRM
#define png_write_chunk omni_png_write_chunk
#define png_write_chunk_data    omni_png_write_chunk_data
#define png_write_chunk_end     omni_png_write_chunk_end
#define png_write_chunk_start   omni_png_write_chunk_start
#define png_write_filter_row    omni_png_write_filter_row
#define png_write_finish_row    omni_png_write_finish_row
#define png_write_gAMA  omni_png_write_gAMA
#define png_write_hIST  omni_png_write_hIST
#define png_write_oFFs  omni_png_write_oFFs
#define png_write_pHYs  omni_png_write_pHYs
#define png_write_sBIT  omni_png_write_sBIT
#define png_write_sig   omni_png_write_sig
#define png_write_start_row     omni_png_write_start_row
#define png_write_tEXt  omni_png_write_tEXt
#define png_write_tIME  omni_png_write_tIME
#define png_write_tRNS  omni_png_write_tRNS
#define png_write_uint_16       omni_png_write_uint_16
#define png_write_uint_32       omni_png_write_uint_32
#define png_write_zTXt  omni_png_write_zTXt


#endif // _PNG_RENAME
