// Starting with Rhapsody RDR, Apple added PNG support to the AppKit.  This is fine and good except that they didn't rename all of they PNG symbols to have a NS_ prefix.  This means that you cannot link the default PNG library with your code w/o doing your own renaming.  They DID rename all of their Zlib symbols apparently, but we still don't want to prevent someone else from linking their own copy of Zlib.
//
// We still want to use our own PNG library to get incremental image loading (which Apple's API doesn't provide).
//
// This list of defines was produced with the command:
//
//  nm -g $OMNI_BUILDOUTPUT/Frameworks/OmniZlib/objects-optimized-debug/*.i386.o | egrep " [DTS] " | awk '{print $3}' | sed 's/^_//' | awk '{printf "#define omni_%s\t%s\n", $1, $1}'

#ifndef _ZLIB_RENAME
#define _ZLIB_RENAME

#define adler32 omni_adler32
#define compress        omni_compress
#define crc32   omni_crc32
#define copyright       omni_copyright
#define deflate omni_deflate
#define deflateCopy     omni_deflateCopy
#define deflateEnd      omni_deflateEnd
#define deflateInit     omni_deflateInit
#define deflateInit2    omni_deflateInit2
#define deflateReset    omni_deflateReset
#define gzclose omni_gzclose
#define gzdopen omni_gzdopen
#define gzerror omni_gzerror
#define gzflush omni_gzflush
#define gzopen  omni_gzopen
#define gzread  omni_gzread
#define gzwrite omni_gzwrite
#define inflate_blocks  omni_inflate_blocks
#define inflate_blocks_free     omni_inflate_blocks_free
#define inflate_blocks_new      omni_inflate_blocks_new
#define inflate_blocks_reset    omni_inflate_blocks_reset
#define inflate_codes   omni_inflate_codes
#define inflate_codes_free      omni_inflate_codes_free
#define inflate_codes_new       omni_inflate_codes_new
#define inflate_fast    omni_inflate_fast
#define inflate omni_inflate
#define inflateEnd      omni_inflateEnd
#define inflateInit     omni_inflateInit
#define inflateInit2    omni_inflateInit2
#define inflateReset    omni_inflateReset
#define inflateSync     omni_inflateSync
#define inflate_hufts   omni_inflate_hufts
#define inflate_trees_bits      omni_inflate_trees_bits
#define inflate_trees_dynamic   omni_inflate_trees_dynamic
#define inflate_trees_fixed     omni_inflate_trees_fixed
#define inflate_trees_free      omni_inflate_trees_free
#define inflate_flush   omni_inflate_flush
#define inflate_mask    omni_inflate_mask
#define ct_align        omni_ct_align
#define ct_flush_block  omni_ct_flush_block
#define ct_init omni_ct_init
#define ct_stored_block omni_ct_stored_block
#define ct_tally        omni_ct_tally
#define uncompress      omni_uncompress
#define z_errmsg        omni_z_errmsg
#define z_error omni_z_error
#define zcalloc omni_zcalloc
#define zcfree  omni_zcfree
#define zlib_version    omni_zlib_version

#endif // _ZLIB_RENAME
